plugins {
    id("java-library")
    id("java-test-fixtures")
    id("chat-bot.java-conventions")
}

group = "eu.jonahbauer.chat"

sourceSets {
    create("config") {
        java {
            srcDir("src/config/java")
        }
    }
}

java {
    registerFeature("config") {
        usingSourceSet(sourceSets["config"])
    }
}

val configCompileOnly by configurations
val configCompileOnlyApi by configurations
val configAnnotationProcessor by configurations

dependencies {
    compileOnlyApi(libs.annotations)
    api(project(path)) {
        capabilities {
            requireCapability("${project.group}:${project.name}-config")
        }
    }
    implementation(libs.gson)

    configCompileOnly(libs.lombok)
    configCompileOnlyApi(libs.annotations)
    configAnnotationProcessor(libs.lombok)
}

tasks.withType<JavaCompile> {
    options.compilerArgs.add("-Xlint:-module")
}