package eu.jonahbauer.chat.server.management.annotations;

import lombok.Getter;
import lombok.RequiredArgsConstructor;

import javax.management.MBeanOperationInfo;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.METHOD)
public @interface ManagedOperation {
    String description() default "";
    Impact impact() default Impact.UNKNOWN;

    @Getter
    @RequiredArgsConstructor
    enum Impact {
        INFO(MBeanOperationInfo.INFO),
        ACTION(MBeanOperationInfo.ACTION),
        ACTION_INFO(MBeanOperationInfo.ACTION_INFO),
        UNKNOWN(MBeanOperationInfo.UNKNOWN);

        private final int code;
    }
}
